/****************************************************************************/
/*                                                                          */
/* This Source Code Form is subject to the terms of the Mozilla Public      */
/* License, v. 2.0. If a copy of the MPL was not distributed with this      */
/* file, You can obtain one at http://mozilla.org/MPL/2.0/.                 */
/*                                                                          */
/****************************************************************************/

/*
 * This file is part of the OpenIPMC project.
 */

/**
 * @file ipmi_msg_manager.c
 * 
 * @author Andre Muller Cascadan
 * 
 * @brief Management interface for messages transmitted and received through the IPMB.
 */

/* FreeRTOS includes. */
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "timers.h"
#include "semphr.h"

#include "stdint.h"

#include "ipmb_0.h"
#include "ipmi_msg_manager.h"
#include "ipmc_ios.h"


TaskHandle_t ipmi_income_requests_manager_task_ptr;

/**
 * Mutex to handle the transmission of requests from the IPMC to Shelf Manager 
 * (should prevent overwriting in the {@link queue_ipmb0_out}).
 */
static SemaphoreHandle_t send_request_mutex = NULL;


/**
 * Reference for the sequence number in the request generated by the IPMC. If the response sent by Shelf Manager did not match the sequence number generated,
 * the ipmi_msg_send_request_ipmb0() function will return {@link IPMI_MSG_SEND_ERROR}.
 */
static uint8_t sequence_number_counter = 0;

/*
 * Send request to the Shelf Manager and wait for the answer.
 */
int ipmi_msg_send_request_ipmb0(uint8_t   netfn,
                                uint8_t   command,
                                uint8_t  *request_bytes,
                                int  req_len, 
                                uint8_t  *completion_code,
                                uint8_t  *response_bytes,
                                int *res_len         )
{

  int i;
  uint8_t data_checksum;
  data_ipmb ipmi_req;
  data_ipmb ipmi_res;
  uint8_t request_seq_num;
  
  
  // Wait for resources to be created
  while ( send_request_mutex == NULL ||
          queue_ipmb0_out    == NULL ||
          queue_ipmb0_res_in == NULL   )

    vTaskDelay( pdMS_TO_TICKS(100) );
  
	
  if ( xSemaphoreTake( send_request_mutex, pdMS_TO_TICKS(250) ) )
  {    
    
    // Compose the General IPMI Request Message
    ipmi_req.length = req_len + 7; // Size = 6 fixed bytes + req_len + 1 byte checksum 
    //ipmi_req.data = (uint8_t*)pvPortMalloc( ipmi_req.length );
    ipmi_req.data[0] = 0x20;  // Destination/Responder Address: ShelfManager
    ipmi_req.data[1] = ( (netfn & 0x3F) << 2 ); // Leave LUN = 0b00
    ipmi_req.data[2] = ( ~(ipmi_req.data[0] + ipmi_req.data[1]) ) + 1; //Header checksum
    ipmi_req.data[3] = ipmb_0_addr;  // Origin/Requester (8 bit IPMB address)
    ipmi_req.data[4] = ( ( sequence_number_counter & 0x3F ) << 2 ); //Leave LUN = 0 
    request_seq_num = sequence_number_counter;  // Holds the picked sequence number
    sequence_number_counter ++; // Counter increment protected by the mutex
    ipmi_req.data[5] = command;
    data_checksum = ipmi_req.data[3] + ipmi_req.data[4] + ipmi_req.data[5];
    for(i=0; i < req_len; i++)
    {
      ipmi_req.data[6+i] = request_bytes[i];
      data_checksum += request_bytes[i];
    }
    ipmi_req.data[6+req_len] = ( ~data_checksum ) + 1;
    
    
    //Send message
    xQueueSendToBack(queue_ipmb0_out, &ipmi_req, portMAX_DELAY);
    
    //Wait for the response
    if ( xQueueReceive(queue_ipmb0_res_in, &ipmi_res, pdMS_TO_TICKS(250) ) == pdFALSE )
    {
      // Timeout. Abort.
      xSemaphoreGive( send_request_mutex );
      return IPMI_MSG_SEND_TIMEOUT;
    }
    
    //Check the sequence number
    if( request_seq_num != (ipmi_res.data[4] & 0xFC)>>2  )
    {
      xSemaphoreGive( send_request_mutex );
      return IPMI_MSG_SEND_ERROR;
    }
    
    // TODO check the Data Checksum
    
    // Deliver the Response to the caller.
    *completion_code = ipmi_res.data[6];
    *res_len = ipmi_res.length - 8;
    for(i=0; i < *res_len; i++)
    {
      response_bytes[i] = ipmi_res.data[7+i]; // Response Data Bytes offset is 7
    }
    //vPortFree(ipmi_res.data);
    
    xSemaphoreGive( send_request_mutex );
    return IPMI_MSG_SEND_OK;
    
  }
  
  return IPMI_MSG_SEND_TIMEOUT;
}



void ipmi_income_requests_manager_task( void *pvParameters )
{
  
   int i;
  
   data_ipmb ipmi_req;
   data_ipmb ipmi_res;
   
   // Buffers for the response
   uint8_t completion;
   uint8_t response_buffer[24];
   int response_len;
   
   uint8_t data_checksum;
   int solve_ok;
   
  // Create the Mutex used for sending requests
  send_request_mutex = xSemaphoreCreateMutex();
  
  
  // Wait for resources to be created
  while ( queue_ipmb0_out    == NULL ||
          queue_ipmb0_req_in == NULL   )
    
    vTaskDelay( pdMS_TO_TICKS(100) );
  
  
  
  for (;;)
  {
  

    // Waits for a request coming from the shelf manager.
    xQueueReceive(queue_ipmb0_req_in, &ipmi_req, portMAX_DELAY);
    
    
    //vTaskDelay( pdMS_TO_TICKS(50) ); // USE THIS ONLY FOR TESTS!!!!
    //ipmc_ios_printf("\nReq rcvd:\r\n");
    //for (i=0; i<ipmi_req.length; i++)
    //{
    //	ipmc_ios_printf("%x ", ipmi_req.data[i]);
    //}
    //ipmc_ios_printf("\r\n");

    // TODO check the checksum

    // Send the request to the solving command switch
    solve_ok = ipmi_msg_solve_request_ipmb0( (ipmi_req.data[1] & 0xFC)>>2,  // NetFn
                                             ipmi_req.data[5],              // Command 
                                             &ipmi_req.data[6],             // Data Bytes
                                             ipmi_req.length - 7,           // Size of the Data Bytes field
                                             &completion,
                                             response_buffer,
                                             &response_len                );
    
    if (solve_ok)
    {
      // Compose the General IPMI Response Message
      ipmi_res.length = response_len + 8; // Size = 7 fixed bytes + response_len + 1 byte checksum 
      //ipmi_res.data = (uint8_t*)pvPortMalloc( ipmi_res.length );
      ipmi_res.data[0] = ipmi_req.data[3];  // Requester Address
      ipmi_res.data[1] = ipmi_req.data[1] + (0x1 << 2); // NetFn added by 1 (response type)
      ipmi_res.data[2] = ( ~(ipmi_res.data[0] + ipmi_res.data[1]) ) + 1; //Header checksum
      ipmi_res.data[3] = ipmi_req.data[0]; // Responder Address
      ipmi_res.data[4] = ipmi_req.data[4]; // Sequence Number
      ipmi_res.data[5] = ipmi_req.data[5]; // Command
      ipmi_res.data[6] = completion;
      data_checksum = ipmi_res.data[3] + ipmi_res.data[4] + ipmi_res.data[5] + ipmi_res.data[6];
      
      for(i=0; i < response_len; i++)
      {
        ipmi_res.data[7+i] = response_buffer[i];
        data_checksum += response_buffer[i];
      }
      ipmi_res.data[7+response_len] = ( ~data_checksum ) + 1;
      
      // Destroy the request
      //vPortFree(ipmi_req.data);
      
      //Send message
      xQueueSendToBack(queue_ipmb0_out, &ipmi_res, portMAX_DELAY);
    }
    else 
    {
      //vPortFree(ipmi_req.data);
    }
  }
  
}
